#!/usr/local/bin/python
'''
Created on Jun 13, 2011

@author: rchen
'''

import urllib2
from urllib2 import HTTPError, URLError

class pds4regURL(object):

	def __init__(self, urlBase = "http://localhost:8080/registry/extrinsics",
				username = "rchen", password = "new4rchen"):
		self.urlBase = urlBase
		self.username = username
		self.password = password
		return

	def buildOpener(self, url):
		auth_handler = urllib2.HTTPPasswordMgrWithDefaultRealm()
		auth_handler.add_password(None, url, self.username, self.password)
		auth_handler2 = urllib2.HTTPBasicAuthHandler(auth_handler)
		opener = urllib2.build_opener(auth_handler2)
		return opener
		# The next 5 lines worked for viewing, not for registering
		# Create an OpenerDirector with support for Basic HTTP Authentication...
		#auth_handler = urllib2.HTTPBasicAuthHandler()
		#auth_handler.add_password(None, urlBase, 'rchen', 'new4rchen')
		#opener = urllib2.build_opener(auth_handler)	# instead of build_opener(), add_handler()

	# emulate `curl https://localhost:8080/registry/extrinsics/stressTesting.T000000 -urchen:new4rchen -k`
	def lidView(self, toView):
		url = self.urlBase + "/" + toView
		opener = self.buildOpener(url)
		#print "viewing", url
		try: response = opener.open(url)
		except HTTPError,e:
			print e.code	# e.g. 404. 409 == duplicate registration
			print e.read()
			raise
		except URLError,e:
			print e.reason	# e.g. a network failure
			raise
		else: return response.read()	

	# emulate curl -X DELETE -v https://localhost:8080/registry/extrinsics/testing.REG.T1.v1.0 -urchen:new4rchen -k
	# Based on http://stackoverflow.com/questions/4511598/how-to-make-http-delete-method-using-urllib2
	def lidDelete(self, toDelete):
		url = self.urlBase + "/" + toDelete 
		opener = self.buildOpener(url)
		request = urllib2.Request(url)
		request.get_method = lambda: 'DELETE'
		# print "deleting", url
		try: response = opener.open(request)
		except HTTPError,e:
			if (e.code == 500):
				print "%s not registered" % toDelete
				raise
			else:
				print "%d: %s" % (e.code, e.read())
				raise
		except URLError,e:
			print e.reason	# e.g. a network failure
			raise
		else:
			return "%s deleted" % toDelete
			#print response.read()	blank for some reason

	# heavily based on http://www.voidspace.org.uk/python/articles/urllib2.shtml
	# emulate `curl -X POST -H "Content-type:application/xml" -v -d <theMainOutput> https://localhost:8080/registry/extrinsics -urchen:new4rchen -k`
	# For -X POST and -d <data>, urllib2.Request(url, data) though data needs encoding, probably not urllib.urlencode(hashValues)
	def lidRegister(self, dataToSend):
		url = self.urlBase
		opener = self.buildOpener(url)
		headers = {"Content-type" : "application/xml"}
		req = urllib2.Request(url, dataToSend, headers)
		# print "registering", url
		try: response = opener.open(req)
		except HTTPError,e:
			if (e.code == 201):	# client on pdsdev returns this on success
				return e.read()	# response.read() is an error
			elif (e.code == 409):
				print "duplicate registration", e.read()
				raise
			else:
				print "%d: %s" % (e.code, e.read())
				raise
		except URLError,e:
			print e.reason	# e.g. a network failure
			raise
		else:			# client on my mac returns this on success with .read()==""
			return response.read()	# if this changes, change e.code==201 also
